﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinListView;

namespace UltraListViewSortComparer
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraListView1.MainColumn.Sorting = Sorting.Descending;
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            ultraListView1.MainColumn.SortComparer = new SortComp();
        }
    }

    public class SortComp : System.Collections.IComparer
    {

        public  int Compare(object o1, object o2)
        {

            UltraListViewItem cell1 = (UltraListViewItem)o1;
            UltraListViewItem cell2 = (UltraListViewItem)o2;
            string strValue1 = cell1.Value as string;
            string strValue2 = cell2.Value as string;
            int nValue1 = 0;
            int nValue2 = 0;
            bool value1IsInt = int.TryParse(strValue1, out nValue1);
            bool value2IsInt = int.TryParse(strValue2, out nValue2);
            int comparison = 0;

            if (value1IsInt && value2IsInt)
            {
                if (nValue1 > nValue2)
                {
                    comparison = 1;
                }
                else if (nValue1 < nValue2)
                {
                    comparison = -1;
                }
                else
                {
                    comparison = 0;
                }
            }
            else
            {
                comparison = string.Compare(strValue1, strValue2, true);
            }

            return comparison;
        }

        
     
    }

}
